Index: /branches/petra/src/FLEXPART.f90
===================================================================
--- /branches/petra/src/FLEXPART.f90	(revision 36)
+++ /branches/petra/src/FLEXPART.f90	(revision 37)
@@ -66,5 +66,5 @@
 
   ! FLEXPART version string
-  flexversion='Version 9.2_beta.r34 (2015-02-12)'
+  flexversion='Version 9.2_beta.r3? (2015-02-25)'
   verbosity=0
 
Index: /branches/petra/src/com_mod.f90
===================================================================
--- /branches/petra/src/com_mod.f90	(revision 36)
+++ /branches/petra/src/com_mod.f90	(revision 37)
@@ -32,4 +32,5 @@
 !        Modifications: 15 August 2013 IP, 
 !        2/2015 PS, add incremental deposition switch
+!        2/2015 PS, change variables for cloud diagnostics
 !                                                                              *
 !*******************************************************************************
@@ -365,8 +366,4 @@
   real :: qvh(0:nxmax-1,0:nymax-1,nuvzmax,2)
   real :: pplev(0:nxmax-1,0:nymax-1,nuvzmax,2)
-  integer(kind=1) :: clouds(0:nxmax-1,0:nymax-1,nzmax,2)
-  integer :: cloudsh(0:nxmax-1,0:nymax-1,2)
-
-
   ! uu,vv,ww [m/2]       wind components in x,y and z direction
   ! uupol,vvpol [m/s]    wind components in polar stereographic projection
@@ -377,8 +374,4 @@
   ! drhodz [kg/m2]       vertical air density gradient
   ! tth,qvh              tth,qvh on original eta levels
-  ! clouds:   no cloud, no precipitation   0
-  !      cloud, no precipitation      1
-  !      rainout  conv/lsp dominated  2/3
-  !      washout  conv/lsp dominated  4/5
 
   ! pplev for the GFS version
@@ -406,4 +399,5 @@
   real :: oli(0:nxmax-1,0:nymax-1,1,2)
   real :: diffk(0:nxmax-1,0:nymax-1,1,2)
+  integer, dimension (0:nxmax-1,0:nymax-1,2) :: icloudbot, icloudthck
 
   ! ps                   surface pressure
@@ -426,4 +420,6 @@
   ! oli [m]              inverse Obukhov length (1/L)
   ! diffk [m2/s]         diffusion coefficient at reference height
+  ! icloudbot (m)        cloud bottom height
+  ! icloudthck (m)       cloud thickness   
 
 
@@ -484,6 +480,4 @@
   real :: qvn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
   real :: pvn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
-  integer(kind=1) :: cloudsn(0:nxmaxn-1,0:nymaxn-1,0:nzmax,2,maxnests)
-  integer :: cloudsnh(0:nxmaxn-1,0:nymaxn-1,2,maxnests)
   real :: rhon(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
   real :: drhodzn(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
@@ -514,4 +508,5 @@
   real :: diffkn(0:nxmaxn-1,0:nymaxn-1,1,2,maxnests)
   real :: vdepn(0:nxmaxn-1,0:nymaxn-1,maxspec,2,maxnests)
+  integer, dimension (0:nxmax-1,0:nymax-1,2,maxnests) :: icloudbotn, icloudthckn
 
 
Index: /branches/petra/src/getfields.f90
===================================================================
--- /branches/petra/src/getfields.f90	(revision 36)
+++ /branches/petra/src/getfields.f90	(revision 37)
@@ -41,4 +41,7 @@
   !   Variables tth,qvh,tthn,qvhn (on eta coordinates) in common block.
   !   Function of nstop extended.
+  !
+  !  3/2015, PS: put in verbosity output
+  !
   !*****************************************************************************
   !                                                                            *
@@ -83,4 +86,5 @@
   integer :: indmin = 1
 
+  call verboutput(verbosity,1,'  getfields')
 
   ! Check, if wind fields are available for the current time step
@@ -125,9 +129,15 @@
     do indj=indmin,numbwf-1
        if (ldirect*wftime(indj+1).gt.ldirect*itime) then
+           call verboutput(verbosity,1,'    call readwind')
           call readwind(indj+1,memind(2),uuh,vvh,wwh)
+           call verboutput(verbosity,1,'    call readwind_nests')
           call readwind_nests(indj+1,memind(2),uuhn,vvhn,wwhn)
+           call verboutput(verbosity,1,'    call calcpar')
           call calcpar(memind(2),uuh,vvh,pvh)
+           call verboutput(verbosity,1,'    call calcpar_nests')
           call calcpar_nests(memind(2),uuhn,vvhn,pvhn)
+           call verboutput(verbosity,1,'    call verttransform')
           call verttransform(memind(2),uuh,vvh,wwh,pvh)
+           call verboutput(verbosity,1,'    call verttransform_nests')
           call verttransform_nests(memind(2),uuhn,vvhn,wwhn,pvhn)
           memtime(2)=wftime(indj+1)
@@ -148,17 +158,29 @@
              (ldirect*wftime(indj+1).gt.ldirect*itime)) then
            memind(1)=1
+            call verboutput(verbosity,1,'    call readwind')
            call readwind(indj,memind(1),uuh,vvh,wwh)
+            call verboutput(verbosity,1,'    call readwind_nests')
            call readwind_nests(indj,memind(1),uuhn,vvhn,wwhn)
+            call verboutput(verbosity,1,'    call calcpar')
            call calcpar(memind(1),uuh,vvh,pvh)
+            call verboutput(verbosity,1,'    call calcpar_nests')
            call calcpar_nests(memind(1),uuhn,vvhn,pvhn)
+            call verboutput(verbosity,1,'    call verttransform')
            call verttransform(memind(1),uuh,vvh,wwh,pvh)
+            call verboutput(verbosity,1,'    call verttransform_nests')
            call verttransform_nests(memind(1),uuhn,vvhn,wwhn,pvhn)
            memtime(1)=wftime(indj)
            memind(2)=2
+            call verboutput(verbosity,1,'    call readwind')
            call readwind(indj+1,memind(2),uuh,vvh,wwh)
+            call verboutput(verbosity,1,'    call readwind_nests')
            call readwind_nests(indj+1,memind(2),uuhn,vvhn,wwhn)
+            call verboutput(verbosity,1,'    call calcpar')
            call calcpar(memind(2),uuh,vvh,pvh)
+            call verboutput(verbosity,1,'    call calcpar_nests')
            call calcpar_nests(memind(2),uuhn,vvhn,pvhn)
+            call verboutput(verbosity,1,'    call verttransform')
            call verttransform(memind(2),uuh,vvh,wwh,pvh)
+            call verboutput(verbosity,1,'    call verttransform_nests')
            call verttransform_nests(memind(2),uuhn,vvhn,wwhn,pvhn)
            memtime(2)=wftime(indj+1)
@@ -175,3 +197,5 @@
   if (lwindinterv.gt.idiffmax) nstop=3
 
+  call verboutput(verbosity,1,'    leaving getfields')
+
 end subroutine getfields
Index: /branches/petra/src/gridcheck.f90
===================================================================
--- /branches/petra/src/gridcheck.f90	(revision 36)
+++ /branches/petra/src/gridcheck.f90	(revision 37)
@@ -32,4 +32,6 @@
   !             LAST UPDATE: 1997-10-10                                 *
   !                                                                     *
+  !**********************************************************************
+  !                                                                     *
   !             Update:      1999-02-08, global fields allowed, A. Stohl*
   !             CHANGE: 11/01/2008, Harald Sodemann, GRIB1/2 input with *
@@ -37,5 +39,8 @@
   !             CHANGE: 03/12/2008, Harald Sodemann, update to f90 with *
   !                                 ECMWF grib_api                      *
-  !                                                                     *
+  !
+  !   3/2015, PS: add GRIB2 coding for deta/dt dp/deta used by ZAMG
+  !  
+  !
   !**********************************************************************
   !                                                                     *
@@ -144,99 +149,103 @@
   if (gribVer.eq.1) then ! GRIB Edition 1
 
-  !print*,'GRiB Edition 1'
-  !read the grib2 identifiers
-  call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'level',isec1(8),iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-
-  !change code for etadot to code for omega
-  if (isec1(6).eq.77) then
-    isec1(6)=135
-  endif
-
-  !print*,isec1(6),isec1(8)
-
-  else
-
-  !print*,'GRiB Edition 2'
-  !read the grib2 identifiers
-  call grib_get_int(igrib,'discipline',discipl,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'parameterCategory',parCat,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'parameterNumber',parNum,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'level',valSurf,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-  call grib_get_int(igrib,'paramId',parId,iret)
-  call grib_check(iret,gribFunction,gribErrorMsg)
-
-  !print*,discipl,parCat,parNum,typSurf,valSurf
-
-  !convert to grib1 identifiers
-  isec1(6)=-1
-  isec1(7)=-1
-  isec1(8)=-1
-  isec1(8)=valSurf     ! level
-  if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
-    isec1(6)=130         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105)) then ! U
-    isec1(6)=131         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105)) then ! V
-    isec1(6)=132         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! Q
-    isec1(6)=133         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then !SP
-    isec1(6)=134         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
-    isec1(6)=135         ! indicatorOfParameter
-  elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually eta dot
-    isec1(6)=135         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
-    isec1(6)=151         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! 10U
-    isec1(6)=165         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! 10V
-    isec1(6)=166         ! indicatorOfParameter
-  elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! 2T
-    isec1(6)=167         ! indicatorOfParameter
-  elseif ((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103)) then ! 2D
-    isec1(6)=168         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
-    isec1(6)=141         ! indicatorOfParameter
-  elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC
-    isec1(6)=164         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP
-    isec1(6)=142         ! indicatorOfParameter
-  elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
-    isec1(6)=143         ! indicatorOfParameter
-  elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
-    isec1(6)=146         ! indicatorOfParameter
-  elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
-    isec1(6)=176         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS
-    isec1(6)=180         ! indicatorOfParameter
-  elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS
-    isec1(6)=181         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
-    isec1(6)=129         ! indicatorOfParameter
-  elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO
-    isec1(6)=160         ! indicatorOfParameter
-  elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
-       (typSurf.eq.1)) then ! LSM
-    isec1(6)=172         ! indicatorOfParameter
-  else
-    print*,'***ERROR: undefined GRiB2 message found!',discipl, &
-         parCat,parNum,typSurf
-  endif
-  if(parId .ne. isec1(6) .and. parId .ne. 77) then
-    write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
-!    stop
-  endif
-
-  endif
+    !print*,'GRiB Edition 1'
+    !read the grib2 identifiers
+    call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'level',isec1(8),iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+
+    !change code for etadot to code for omega
+    if (isec1(6).eq.77) then
+      isec1(6)=135
+    endif
+
+    !print*,isec1(6),isec1(8)
+
+  else ! GRIB 2
+
+    !print*,'GRiB Edition 2'
+    ! read the grib2 identifiers
+
+    call grib_get_int(igrib,'discipline',discipl,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'parameterCategory',parCat,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'parameterNumber',parNum,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'level',valSurf,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+    call grib_get_int(igrib,'paramId',parId,iret)
+    call grib_check(iret,gribFunction,gribErrorMsg)
+
+    !print*,discipl,parCat,parNum,typSurf,valSurf
+
+    ! convert to grib1 identifiers
+
+    isec1(6)=-1
+    isec1(7)=-1
+    isec1(8)=-1
+    isec1(8)=valSurf     ! level
+    if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! T
+      isec1(6)=130         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105)) then ! U
+      isec1(6)=131         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105)) then ! V
+      isec1(6)=132         ! indicatorOfParameter
+    elseif ((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105)) then ! Q
+      isec1(6)=133         ! indicatorOfParameter
+    elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then !SP
+      isec1(6)=134         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually detadtdpdeta
+      isec1(6)=135         ! indicatorOfParameter
+    elseif ((parCat.eq.128).and.(parNum.eq.77)) then ! W, actually detadtdpdeta
+      isec1(6)=135         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.8)) then ! Omega, actually detadtdpdeta
+      isec1(6)=135         ! indicatorOfParameter
+    elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101)) then !SLP
+      isec1(6)=151         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! 10U
+      isec1(6)=165         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! 10V
+      isec1(6)=166         ! indicatorOfParameter
+    elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! 2T
+      isec1(6)=167         ! indicatorOfParameter
+    elseif ((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103)) then ! 2D
+      isec1(6)=168         ! indicatorOfParameter
+    elseif ((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SD
+      isec1(6)=141         ! indicatorOfParameter
+    elseif ((parCat.eq.6).and.(parNum.eq.1) .or. parId .eq. 164) then ! CC
+      isec1(6)=164         ! indicatorOfParameter
+    elseif ((parCat.eq.1).and.(parNum.eq.9) .or. parId .eq. 142) then ! LSP
+      isec1(6)=142         ! indicatorOfParameter
+    elseif ((parCat.eq.1).and.(parNum.eq.10)) then ! CP
+      isec1(6)=143         ! indicatorOfParameter
+    elseif ((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1)) then ! SHF
+      isec1(6)=146         ! indicatorOfParameter
+    elseif ((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1)) then ! SR
+      isec1(6)=176         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.17) .or. parId .eq. 180) then ! EWSS
+      isec1(6)=180         ! indicatorOfParameter
+    elseif ((parCat.eq.2).and.(parNum.eq.18) .or. parId .eq. 181) then ! NSSS
+      isec1(6)=181         ! indicatorOfParameter
+    elseif ((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
+      isec1(6)=129         ! indicatorOfParameter
+    elseif ((parCat.eq.3).and.(parNum.eq.7) .or. parId .eq. 160) then ! SDO
+      isec1(6)=160         ! indicatorOfParameter
+    elseif ((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and. &
+         (typSurf.eq.1)) then ! LSM
+      isec1(6)=172         ! indicatorOfParameter
+    else
+      print*,'***ERROR: undefined GRiB2 message found!',discipl, &
+           parCat,parNum,typSurf
+    endif
+    if(parId .ne. isec1(6) .and. parId .ne. 77) then
+      write(*,*) 'parId',parId, 'isec1(6)',isec1(6)
+  !    stop
+    endif
+
+  endif ! GRIB 1 / GRIB 2 cases
 
   !get the size and data of the values array
Index: /branches/petra/src/interpol_rain.f90
===================================================================
--- /branches/petra/src/interpol_rain.f90	(revision 36)
+++ /branches/petra/src/interpol_rain.f90	(revision 37)
@@ -1,4 +1,4 @@
 !**********************************************************************
-! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
+! Copyright 1998-2015                                                 *
 ! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
 ! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
@@ -20,6 +20,7 @@
 !**********************************************************************
 
-subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
-       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
+subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx,ny, &
+       memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3, &
+       icbot,ictop)
   !                          i   i   i    i    i     i   i
   !i    i    i  i    i     i      i      i     o     o     o
@@ -40,4 +41,8 @@
   !                                                                           *
   !     30 August 1996                                                        *
+  !****************************************************************************
+  ! Petra Seibert, 2011/2012-2015:
+  !  Add interpolation of cloud bottom and cloud thickness
+  !  for fix to SE's new wet scavenging scheme
   !                                                                           *
   !****************************************************************************
@@ -66,15 +71,18 @@
   !                                                                           *
   !****************************************************************************
+  
+  use com_mod, only: icloudbot, icloudthck
+  use par_mod, only: icmv
 
   implicit none
 
   integer :: nx,ny,nxmax,nymax,nzmax,memind(2),m,ix,jy,ixp,jyp
-  integer :: itime,itime1,itime2,level,indexh
+  integer :: itime,itime1,itime2,level,indexh,ip1,ip2,ip3,ip4 
+  integer :: icbot,icthck,ictop,ipsum
   real :: yy1(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy2(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy3(0:nxmax-1,0:nymax-1,nzmax,2)
-  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
+  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2),cbot(2),cthck(2)
   real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
-
 
 
@@ -112,5 +120,7 @@
   !***********************
 
+  memind_loop: &
   do m=1,2
+
     indexh=memind(m)
 
@@ -127,5 +137,45 @@
          + p3*yy3(ix ,jyp,level,indexh) &
          + p4*yy3(ixp,jyp,level,indexh)
-  end do
+
+
+! PS clouds:
+    ip1=1
+    ip2=1
+    ip3=1
+    ip4=1
+    if (icloudbot(ix ,jy ,indexh) .eq. icmv) ip1=0
+    if (icloudbot(ixp,jy ,indexh) .eq. icmv) ip2=0
+    if (icloudbot(ix ,jyp,indexh) .eq. icmv) ip3=0
+    if (icloudbot(ixp,jyp,indexh) .eq. icmv) ip4=0
+    ipsum = ip1+ip2+ip3+ip4
+    if (ipsum .eq. 0) then
+      cbot(m)=icmv
+    else
+      cbot(m)=(ip1*p1*icloudbot(ix ,jy ,indexh) &
+             + ip2*p2*icloudbot(ixp,jy ,indexh) &
+             + ip3*p3*icloudbot(ix ,jyp,indexh) &
+             + ip4*p4*icloudbot(ixp,jyp,indexh)) / ipsum
+    endif
+
+    ip1=1
+    ip2=1
+    ip3=1
+    ip4=1
+    if (icloudthck(ix ,jy ,indexh) .eq. icmv) ip1=0
+    if (icloudthck(ixp,jy ,indexh) .eq. icmv) ip2=0
+    if (icloudthck(ix ,jyp,indexh) .eq. icmv) ip3=0
+    if (icloudthck(ixp,jyp,indexh) .eq. icmv) ip4=0
+    ipsum = ip1+ip2+ip3+ip4
+    if (ipsum .eq. 0) then
+      cthck(m)=icmv
+    else
+      cthck(m)=(ip1*p1*icloudthck(ix ,jy ,indexh) &
+              + ip2*p2*icloudthck(ixp,jy ,indexh) &
+              + ip3*p3*icloudthck(ix ,jyp,indexh) &
+              + ip4*p4*icloudthck(ixp,jyp,indexh)) / ipsum
+    endif
+! PS end clouds
+
+  enddo memind_loop
 
 
@@ -142,4 +192,21 @@
   yint3=(y3(1)*dt2+y3(2)*dt1)/dt
 
+! PS clouds:
+  icbot = nint( (cbot(1)*dt2 + cbot(2)*dt1)/dt )
+  if (nint(cbot(1)) .eq. icmv) icbot=cbot(2) 
+  if (nint(cbot(2)) .eq. icmv) icbot=cbot(1) 
+
+  icthck = nint( (cthck(1)*dt2 + cthck(2)*dt1)/dt )
+  if (nint(cthck(1)) .eq. icmv) icthck=cthck(2) 
+  if (nint(cthck(2)) .eq. icmv) icthck=cthck(1) 
+
+  if (icbot .ne. icmv .and. icthck .ne. icmv) then
+    ictop = icbot + icthck ! convert cloud thickness to cloud top
+  else
+    icbot=icmv
+    ictop=icmv
+  endif
+! PS end clouds
+
 
 end subroutine interpol_rain
Index: /branches/petra/src/interpol_rain_nests.f90
===================================================================
--- /branches/petra/src/interpol_rain_nests.f90	(revision 36)
+++ /branches/petra/src/interpol_rain_nests.f90	(revision 37)
@@ -1,4 +1,4 @@
 !**********************************************************************
-! Copyright 1998,1999,2000,2001,2002,2005,2007,2008,2009,2010         *
+! Copyright 1998-2015                                                 *
 ! Andreas Stohl, Petra Seibert, A. Frank, Gerhard Wotawa,             *
 ! Caroline Forster, Sabine Eckhardt, John Burkhart, Harald Sodemann   *
@@ -21,6 +21,7 @@
 
 subroutine interpol_rain_nests(yy1,yy2,yy3,nxmaxn,nymaxn,nzmax, &
-       maxnests,ngrid,nxn,nyn,memind,xt,yt,level,itime1,itime2,itime, &
-       yint1,yint2,yint3)
+       maxnests,ngrid,nxn,nyn, &
+       memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3, &
+       icbot,ictop)
   !                                i   i   i    i      i      i
   !   i       i    i   i    i    i  i    i     i      i      i
@@ -44,4 +45,9 @@
   !                                                                           *
   !     15 March 2000                                                         *
+  !                                                                           *
+  !****************************************************************************
+  ! Petra Seibert, 2011/2012-2015:
+  !  Add interpolation of cloud bottom and cloud thickness
+  !  for fix to SE's new wet scavenging scheme
   !                                                                           *
   !****************************************************************************
@@ -71,24 +77,25 @@
   !****************************************************************************
 
+  use com_mod, only: icloudbotn, icloudthckn
+  use par_mod, only: icmv
+
   implicit none
 
   integer :: maxnests,ngrid
-  integer :: nxn(maxnests),nyn(maxnests),nxmaxn,nymaxn,nzmax,memind(2)
-  integer :: m,ix,jy,ixp,jyp,itime,itime1,itime2,level,indexh
+  integer :: nxn(maxnests),nyn(maxnests),nxmaxn,nymaxn,nzmax,memind(2),m
+  integer :: ix,jy,ixp,jyp
+  integer :: itime,itime1,itime2,level,indexh,ip1,ip2,ip3,ip4
+  integer :: icbot,ictop,icthck,ipsum
   real :: yy1(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
   real :: yy2(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
   real :: yy3(0:nxmaxn-1,0:nymaxn-1,nzmax,2,maxnests)
-  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
+  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2),cbot(2),cthck(2)
   real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
-
-
 
   ! If point at border of grid -> small displacement into grid
   !***********************************************************
 
-  if (xt.ge.(real(nxn(ngrid)-1)-0.0001)) &
-       xt=real(nxn(ngrid)-1)-0.0001
-  if (yt.ge.(real(nyn(ngrid)-1)-0.0001)) &
-       yt=real(nyn(ngrid)-1)-0.0001
+  if (xt.ge.(real(nxn(ngrid)-1)-0.0001)) xt=real(nxn(ngrid)-1)-0.0001
+  if (yt.ge.(real(nyn(ngrid)-1)-0.0001)) yt=real(nyn(ngrid)-1)-0.0001
 
 
@@ -119,5 +126,7 @@
   !***********************
 
+  memind_loop: &
   do m=1,2
+
     indexh=memind(m)
 
@@ -134,5 +143,44 @@
          + p3*yy3(ix ,jyp,level,indexh,ngrid) &
          + p4*yy3(ixp,jyp,level,indexh,ngrid)
-  end do
+
+! PS clouds:
+    ip1=1
+    ip2=1
+    ip3=1
+    ip4=1
+    if (icloudbotn(ix ,jy ,indexh,ngrid) .eq. icmv) ip1=0
+    if (icloudbotn(ixp,jy ,indexh,ngrid) .eq. icmv) ip2=0
+    if (icloudbotn(ix ,jyp,indexh,ngrid) .eq. icmv) ip3=0
+    if (icloudbotn(ixp,jyp,indexh,ngrid) .eq. icmv) ip4=0
+    ipsum = ip1+ip2+ip3+ip4
+    if (ipsum .eq. 0) then
+      cbot(m)=icmv
+    else
+      cbot(m)=(ip1*p1*icloudbotn(ix ,jy ,indexh,ngrid) &
+             + ip2*p2*icloudbotn(ixp,jy ,indexh,ngrid) &
+             + ip3*p3*icloudbotn(ix ,jyp,indexh,ngrid) &
+             + ip4*p4*icloudbotn(ixp,jyp,indexh,ngrid)) / ipsum
+    endif
+
+    ip1=1
+    ip2=1
+    ip3=1
+    ip4=1
+    if (icloudthckn(ix ,jy ,indexh,ngrid) .eq. icmv) ip1=0
+    if (icloudthckn(ixp,jy ,indexh,ngrid) .eq. icmv) ip2=0
+    if (icloudthckn(ix ,jyp,indexh,ngrid) .eq. icmv) ip3=0
+    if (icloudthckn(ixp,jyp,indexh,ngrid) .eq. icmv) ip4=0
+    ipsum = ip1+ip2+ip3+ip4
+    if (ipsum .eq. 0) then
+      cthck(m)=icmv
+    else
+      cthck(m)=(ip1*p1*icloudthckn(ix ,jy ,indexh,ngrid) &
+              + ip2*p2*icloudthckn(ixp,jy ,indexh,ngrid) &
+              + ip3*p3*icloudthckn(ix ,jyp,indexh,ngrid) &
+              + ip4*p4*icloudthckn(ixp,jyp,indexh,ngrid)) / ipsum
+    endif
+! PS end clouds
+
+  enddo memind_loop
 
 
@@ -150,3 +198,21 @@
 
 
+! PS clouds:
+  icbot = nint( (cbot(1)*dt2 + cbot(2)*dt1)/dt )
+  if (nint(cbot(1)) .eq. icmv) icbot=cbot(2) 
+  if (nint(cbot(2)) .eq. icmv) icbot=cbot(1) 
+
+  icthck = nint( (cthck(1)*dt2 + cthck(2)*dt1)/dt )
+  if (nint(cthck(1)) .eq. icmv) icthck=cthck(2) 
+  if (nint(cthck(2)) .eq. icmv) icthck=cthck(1) 
+
+  if (icbot .ne. icmv .and. icthck .ne. icmv) then
+    ictop = icbot + icthck ! convert cloud thickness to cloud top
+  else
+    icbot=icmv
+    ictop=icmv
+  endif
+! PS end clouds
+
+
 end subroutine interpol_rain_nests
Index: /branches/petra/src/par_mod.f90
===================================================================
--- /branches/petra/src/par_mod.f90	(revision 36)
+++ /branches/petra/src/par_mod.f90	(revision 37)
@@ -103,9 +103,10 @@
 
   integer,parameter :: idiffnorm=10800, idiffmax=2*idiffnorm, minstep=1
+  integer,parameter :: itagekernmin=10800
 
   ! idiffnorm [s]           normal time interval between two wind fields
   ! idiffmax [s]            maximum time interval between two wind fields
   ! minstep [s]             minimum time step to be used within FLEXPART
-
+  ! itagekernmin [s]        minimum particle age [s] for using output kernel
 
   !*****************************************************************
@@ -265,10 +266,20 @@
 
 !******************************************************
-! integer code for missing values, used in wet scavenging (PS, 2012)
+! for use in wet scavenging (PS, 2012, 2015)
 !******************************************************
 
-    !  integer icmv
-    !  parameter(icmv=-9999)
-      integer,parameter ::  icmv=-9999
+  integer,parameter :: icmv=-9999 ! integer code for missing values 
+  ! some cloud heights used when trying to construct reasonable cloud:
+  integer,parameter :: icloudtopconvmin = 6000
+  integer,parameter :: icloudtopmin = 3000
+  integer,parameter :: icloudbot1 = 500, icloudtop1 =  8000
+  integer,parameter :: icloudbot2 = 0,   icloudtop2 = 10000
+  
+  real, parameter :: precmin = 0.002 ! minimum prec in mm/h for cloud diagnostics
+  real, parameter :: rhmininit = 0.90 ! standard condition for presence of clouds
+! PS       note that original by Sabine Eckhart was 80%
+! PS       however, for T<-20 C we consider saturation over ice
+! PS       so I think 90% should be enough          
+  real, parameter :: rhminx = 0.30 ! extreme condition for presence of clouds
 
 ! Parameters for testing
Index: /branches/petra/src/readcommand.f90
===================================================================
--- /branches/petra/src/readcommand.f90	(revision 36)
+++ /branches/petra/src/readcommand.f90	(revision 37)
@@ -235,13 +235,16 @@
     read(unitcommand,*,iostat=icmdstat) linit_cond
     if (icmdstat .gt. 0) &
-      print*, 'readcommand: linit_cond not read properly',icmdstat,linit_cond
-    if (old) call skplin(3,unitcommand)
-    read(unitcommand,*,iostat=icmdstat) surf_only
+      print*, 'readcommand: linit_cond not present or no read properly,&
+       & - check values: ',icmdstat,linit_cond
+    if (old) call skplin(3,unitcommand)
+    read(unitcommand,*,iostat=icmdstat) icmdstat,surf_only
     if (icmdstat .gt. 0) &
-      print*, 'readcommand: linit_cond not read properly',icmdstat,surf_only
-    if (old) call skplin(3,unitcommand)
-    read(unitcommand,*,iostat=icmdstat) ldep_incr
+      print*, 'readcommand: surf_only not present or not read properly&
+       & - check values: ',icmdstat,surf_only
+    if (old) call skplin(3,unitcommand)
+    read(unitcommand,*,iostat=icmdstat) icmdstat,ldep_incr
     if (icmdstat .gt. 0) &
-      print*, 'readcommand: linit_cond not read properly',icmdstat, ldep_incr
+      print*, 'readcommand: ldep_incr not present or not read properly&
+       & - check values: ',icmdstat, ldep_incr
     close(unitcommand)
 
@@ -416,17 +419,5 @@
 
 
-  ! For backward runs one releasefield for all releases makes no sense,
-  ! For quasilag and domainfill ioutputforechrelease is forbidden
-  !*****************************************************************************
-
-  if ((ldirect .lt. 0) .and. (ioutputforeachrelease .eq. 0)) then
-      write(*,*) '#### FLEXPART MODEL ERROR! FILE COMMAND:     ####'
-      write(*,*) '#### FOR BACKWARD RUNS, IOUTPUTFOREACHRLEASE ####'
-      write(*,*) '#### MUST BE SET TO ONE!                     ####'
-      stop
-  endif
-
-
-  ! For backward runs one releasefield for all releases makes no sense,
+  ! For domainfill runs one releasefield for all releases makes no sense,
   ! and is "forbidden"
   !*****************************************************************************
